Index: /GTP/trunk/Lib/Vis/Preprocessing/src/RenderTexture.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/RenderTexture.cpp	(revision 1940)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/RenderTexture.cpp	(revision 2575)
@@ -240,5 +240,5 @@
   {
     // [Redge]
-#if defined(_DEBUG) | defined(DEBUG)
+#if defined(_DEBUG) || defined(DEBUG)
     fprintf(stderr, "Warning: OpenGL extension GL_ARB_depth_texture not available.\n"
                     "         Using glReadPixels() to emulate behavior.\n");
@@ -250,5 +250,5 @@
   }
   SetLastError(0);
-#else
+#else // _WIN32
   if (!GLXEW_SGIX_pbuffer)
   {
@@ -270,5 +270,5 @@
     PrintExtensionError("Some GLX render texture extension");
   }
-#endif
+#endif // _WIN32
 
   if (_bInitialized)
@@ -292,5 +292,5 @@
 	  PrintExtensionError("NV_float_buffer or ATI_texture_float");
   }
-#else
+#else // _WIN32
   if (_bFloat && _bIsTexture && !GLXEW_NV_float_buffer)
   {
@@ -298,5 +298,5 @@
     return false;
   }
-#endif  
+#endif // _WIN32
   if (!_bFloat && !GLEW_NV_texture_rectangle)
   {
@@ -461,7 +461,9 @@
           }
         }
-#else if defined(DEBUG) || defined(_DEBUG)
+#else // _WIN32 
+#if defined(DEBUG) || defined(_DEBUG)
         printf("RenderTexture Error: Render-to-Texture not supported in Linux\n");
-#endif    
+#endif
+#endif // _WIN32 
       }
     }
@@ -850,5 +852,5 @@
   _iBits[5] = (wglGetPixelFormatAttribivARB(_hDC, iFormat, 0, 1, &attrib, &value)) ? value : 0; 
  
-#if defined(_DEBUG) | defined(DEBUG)
+#if defined(_DEBUG) || defined(DEBUG)
   fprintf(stderr, "Created a %dx%d RenderTexture with BPP(%d, %d, %d, %d)",
           _iWidth, _iHeight, _iBits[0], _iBits[1], _iBits[2], _iBits[3]);
@@ -857,5 +859,5 @@
   fprintf(stderr, "\n");
 #endif
-#else
+#else // _WIN32 
   _pDpy = glXGetCurrentDisplay();
   GLXContext context = glXGetCurrentContext();
@@ -936,5 +938,5 @@
   // XXX Query the color format
 
-#endif
+#endif // _WIN32 
   
   return true;
@@ -982,5 +984,5 @@
     return true;
   }
-#else
+#else // _WIN32 
   if ( _hPBuffer )
   {
@@ -992,5 +994,5 @@
     return true;
   }
-#endif
+#endif // _WIN32 
   return false;
 }
@@ -1080,5 +1082,5 @@
     return false;
   }
-#else
+#else // _WIN32 
   _hPreviousContext = glXGetCurrentContext();
   _hPreviousDrawable = glXGetCurrentDrawable();
@@ -1087,5 +1089,5 @@
     return false;
   }
-#endif
+#endif // _WIN32 
   
   return true;
@@ -1196,5 +1198,5 @@
     }
   }
-#else
+#else // _WIN32 
   assert(_bIsTexture);
   glBindTexture(_iTextureTarget, _iTextureID);
@@ -1208,5 +1210,5 @@
     }
   }
-#endif
+#endif // _WIN32 
   return true;
 }
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.h	(revision 2575)
@@ -4,4 +4,5 @@
 #include "common.h"
 #include "PvsDefinitions.h"
+#include "Intersectable.h"
 
 //
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2574)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/run_test2	(revision 2575)
@@ -3,5 +3,5 @@
 
 #COMMAND="./release/preprocessor.exe -preprocessor_quit_on_finish+"
-COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer- -preprocessor_evaluate_filter- -samples_per_evaluation=5000000 -samples_per_pass=500000 -total_samples=6000000"
+COMMAND="../scripts/preprocessor.sh -preprocessor_quit_on_finish+ -preprocessor_use_gl_renderer+ -preprocessor_evaluate_filter- -samples_per_evaluation=5000000 -samples_per_pass=500000 -total_samples=6000000"
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.h	(revision 2575)
@@ -303,7 +303,7 @@
 	/** Sets parent node.
 	*/
-	inline void BspNode::SetParent(BspInterior *parent)
-	{
-		mParent = parent;
+	inline void SetParent(BspInterior *parent)
+	{
+	  mParent = parent;
 	}
 
@@ -375,5 +375,5 @@
 	/** Returns split plane.
 	*/
-	Plane3 BspInterior::GetPlane() const
+	Plane3 GetPlane() const
 	{
 		return mPlane;
@@ -441,5 +441,5 @@
 	/** @return true since it is an interior node 
 	*/
-	bool BspLeaf::IsLeaf() const 
+        bool IsLeaf() const 
 	{ 
 		return true; 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp	(revision 2023)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.cpp	(revision 2575)
@@ -1,6 +1,14 @@
 #include "OcclusionQuery.h"
 #include <iostream>
+
+
+#ifdef _WIN32
 #include <glInterface.h>
-
+#else
+#include <GL/gl.h>
+#include <GL/glu.h>
+//#include <GL/glxext.h>
+#include <SDL/SDL_opengl.h>
+#endif
 
 using namespace std;
@@ -17,9 +25,15 @@
 	if (sUseArbQueries)
 	{
-		glGenQueriesARB(1, &id);
+#ifdef _ARBGL
+	  // VH
+	  glGenQueriesARB(1, &id);
+#endif
 	}
 	else
 	{		
+#ifdef _ARBGL
+	  // VH
 		glGenOcclusionQueriesNV(1, &id);
+#endif
 	}
 }
@@ -34,9 +48,15 @@
 	if (sUseArbQueries)
 	{
+#ifdef _ARBGL
+	  // VH
 		glDeleteQueriesARB(1, &mId);
+#endif
 	}
 	else
 	{
+#ifdef _ARBGL
+	  // VH
 		glDeleteOcclusionQueriesNV(1, &mId);
+#endif
 	}
 	
@@ -47,9 +67,15 @@
 	if (sUseArbQueries)
 	{
+#ifdef _ARBGL
+	  // VH
 		glBeginQueryARB(GL_SAMPLES_PASSED_ARB, mId);
+#endif
 	}
 	else
 	{
+#ifdef _ARBGL
+	  // VH
 		glBeginOcclusionQueryNV(mId);
+#endif
 	}
 }
@@ -59,9 +85,15 @@
 	if (sUseArbQueries)
 	{
+#ifdef _ARBGL
+	  // VH
 		glEndQueryARB(GL_SAMPLES_PASSED_ARB);
+#endif
 	}
 	else
 	{
+#ifdef _ARBGL
+	  // VH
 		glEndOcclusionQueryNV();	
+#endif
 	}
 }
@@ -79,15 +111,19 @@
 	if (sUseArbQueries)
 	{
+#ifdef _ARBGL
+	  // VH
 		//GLint available;
 		glGetQueryObjectuivARB(mId,
 							   GL_QUERY_RESULT_AVAILABLE_ARB,
-                               &available);
+				       &available);
+#endif		
 		return available == GL_TRUE;
 	}
 	else
 	{
-		
-		glGetOcclusionQueryuivNV(mId, GL_PIXEL_COUNT_AVAILABLE_NV, &available);
-
+#ifdef _ARBGL
+	  // VH
+	  glGetOcclusionQueryuivNV(mId, GL_PIXEL_COUNT_AVAILABLE_NV, &available);
+#endif
 		return available == GL_TRUE;
 	}
@@ -102,11 +138,16 @@
 	if (sUseArbQueries)
 	{
+#ifdef _ARBGL
+	  // VH
 		glGetQueryObjectuivARB(mId, GL_QUERY_RESULT_ARB, &sampleCount);
+#endif
 		return sampleCount;
 	}
 	else
 	{	
-
+#ifdef _ARBGL
+	  // VH
 		glGetOcclusionQueryuivNV(mId, GL_PIXEL_COUNT_NV, &sampleCount);
+#endif		
 		return sampleCount;
 	}	
@@ -124,9 +165,15 @@
 		if (sUseArbQueries)
 		{
+#ifdef _ARBGL
+	  // VH
 			glGenQueriesARB(n, (unsigned int *)newQueries);
+#endif
 		}
 		else
 		{
-			glGenOcclusionQueriesNV(n, (unsigned int *)newQueries);
+#ifdef _ARBGL
+	  // VH		  
+		  glGenOcclusionQueriesNV(n, (unsigned int *)newQueries);
+#endif		  
 		}
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Vector3.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Vector3.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Vector3.h	(revision 2575)
@@ -250,4 +250,9 @@
 };
 
+// forward declaration
+extern Vector3 UniformRandomVector(const Vector3 &normal);
+extern Vector3 UniformRandomVector();
+extern Vector3 UniformRandomVector(const float r1, const float r2);
+  
 inline Vector3
 ArbitraryNormal(const Vector3 &N)
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 2347)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 2575)
@@ -3478,8 +3478,8 @@
 			BspInterior *in = static_cast<BspInterior *>(node);
 
-			Plane3 &splitPlane = in->GetPlane();
+			Plane3 *splitPlane = &(in->GetPlane());
 			
-			const int entSide = splitPlane.Side(entp, thresh);
-			const int extSide = splitPlane.Side(extp, thresh);
+			const int entSide = splitPlane->Side(entp, thresh);
+			const int extSide = splitPlane->Side(extp, thresh);
 
 			if (entSide < 0) 
@@ -3518,5 +3518,5 @@
 
 			// find intersection of ray segment with plane
-			extp = splitPlane.FindIntersection(origin, extp, &t);
+			extp = splitPlane->FindIntersection(origin, extp, &t);
 		} 
 		else
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 2574)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.h	(revision 2575)
@@ -364,10 +364,10 @@
 	/** Creates mesh for this view cell.
 	*/
-	virtual void CreateMesh(ViewCell *vc) = NULL;
+	virtual void CreateMesh(ViewCell *vc) = 0;
 	/** Writes view cells to disc.
 	*/
 	virtual bool ExportViewCells(const string filename, 
-								 const bool exportPvs, 
-								 const ObjectContainer &objects);
+				     const bool exportPvs, 
+				     const ObjectContainer &objects);
 	/** Casts beam to collect view cells.
 	*/
@@ -626,5 +626,5 @@
 									   const int maxRays,
 									   const string &prefix,
-									   VssRayContainer *visRays = NULL) = NULL;
+									   VssRayContainer *visRays = NULL) = 0;
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.cpp	(revision 2332)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ObjectPvs.cpp	(revision 2575)
@@ -1,4 +1,6 @@
 #include <iostream>
 #include <stack>
+
+#include "Mesh.h"
 #include "ObjectPvs.h"
 #include "Intersectable.h"
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h	(revision 2571)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/RayCaster.h	(revision 2575)
@@ -20,5 +20,5 @@
 class Preprocessor;
 struct SimpleRay;
-
+class RayPacket2x2;
 
 /** This class provides an interface for ray casting.
@@ -29,167 +29,174 @@
 public:
 	
-	enum {
-	  INTERNAL_RAYCASTER = 0,
-	  INTEL_RAYCASTER
-	};
-
-	RayCaster(const Preprocessor &preprocessor);
-
-	virtual ~RayCaster();
-
-	virtual int Type() const = 0;
-
-	/** Wrapper for casting single ray.
-		@returns ray or NULL if invalid
-	*/
-	VssRay *CastRay(const SimpleRay &simpleRay,
-					const AxisAlignedBox3 &box,
-					const bool castDoubleRay);
-
-	virtual int CastRay(const SimpleRay &simpleRay,
-						VssRayContainer &vssRays,
-						const AxisAlignedBox3 &box,
-						const bool castDoubleRay,
-						const bool pruneInvalidRays = true) = 0;
-
-	virtual void CastRays16(SimpleRayContainer &rays,
-							VssRayContainer &vssRays,
-							const AxisAlignedBox3 &sbox,
-							const bool castDoubleRay,
-							const bool pruneInvalidRays = true) = 0;
-
+  enum {
+    INTERNAL_RAYCASTER = 0,
+    INTEL_RAYCASTER = 1,
+    HAVRAN_RAYCASTER = 2
+  };
+
+  RayCaster(const Preprocessor &preprocessor);
+
+  virtual ~RayCaster();
+  
+  virtual int Type() const = 0;
+
+  /** Wrapper for casting single ray.
+      @returns ray or NULL if invalid
+  */
+  VssRay *CastRay(const SimpleRay &simpleRay,
+		  const AxisAlignedBox3 &box,
+		  const bool castDoubleRay);
+
+  virtual int CastRay(const SimpleRay &simpleRay,
+		      VssRayContainer &vssRays,
+		      const AxisAlignedBox3 &box,
+		      const bool castDoubleRay,
+		      const bool pruneInvalidRays = true) = 0;
+
+  virtual void CastRays16(SimpleRayContainer &rays,
+			  VssRayContainer &vssRays,
+			  const AxisAlignedBox3 &sbox,
+			  const bool castDoubleRay,
+			  const bool pruneInvalidRays = true) = 0;
+  
   virtual void CastRays(
-						SimpleRayContainer &rays,
-						VssRayContainer &vssRays,
-						const AxisAlignedBox3 &sbox,
-						const bool castDoubleRay,
-						const bool pruneInvalidRays = true);
-
+			SimpleRayContainer &rays,
+			VssRayContainer &vssRays,
+			const AxisAlignedBox3 &sbox,
+			const bool castDoubleRay,
+			const bool pruneInvalidRays = true);
+
+  // Just for testing concept
+  virtual void CastRaysPacket2x2(RayPacket2x2 &raysPack,
+				 bool castDoubleRay,
+				 const bool pruneInvalidRays = true)
+  { }
+  
   /*virtual void CastRaysEye4(SimpleRayContainer &rays,
-							  VssRayContainer &vssRays,
-							  const AxisAlignedBox3 &sbox,
-							  const bool castDoubleRay,
-							  const bool pruneInvalidRays = true) = 0;
-*/
-	virtual void
-	SortRays(SimpleRayContainer &rays);
-
-
-	// pool of vss rays to be used in one pass of the sampling
-	struct VssRayPool 
-	{
-		VssRayPool(): mRays(NULL), mIndex(0), mNumber(0) 
-		{}
-
-		~VssRayPool() 
-		{
-			DEL_PTR(mRays);
-		}
-
-		void Reserve(const int number) 
-		{
-			DEL_PTR(mRays);
-			mRays = new VssRay[number];
-			mNumber = number;
-		}
-
-		void Clear() 
-		{
-			mIndex = 0;
-		}
-		
-		VssRay *Alloc() 
-		{
-			// reset pool
-			if (mIndex == mNumber)
-				mIndex = 0;
-			return mRays + mIndex ++;
-		}
-
-	protected:
-
-		VssRay *mRays;
-		int mIndex;
-		int mNumber;
-	};
-
-	VssRayPool mVssRayPool;
-
-	void ReserveVssRayPool(const int n) 
-	{
-		mVssRayPool.Reserve(n);
-	}
-
-	void InitPass() 
-	{
-		mVssRayPool.Clear();
-	}
-
-
+    VssRayContainer &vssRays,
+    const AxisAlignedBox3 &sbox,
+    const bool castDoubleRay,
+    const bool pruneInvalidRays = true) = 0;
+  */
+
+  virtual void
+  SortRays(SimpleRayContainer &rays);
+
+
+  // pool of vss rays to be used in one pass of the sampling
+  struct VssRayPool 
+  {
+    VssRayPool(): mRays(NULL), mIndex(0), mNumber(0) 
+    {}
+    
+    ~VssRayPool() 
+    {
+      delete []mRays;
+    }
+    
+    void Reserve(const int number) 
+    {
+      DEL_PTR(mRays);
+      mRays = new VssRay[number];
+      mNumber = number;
+    }
+    
+    void Clear() 
+    {
+      mIndex = 0;
+    }
+    
+    VssRay *Alloc() 
+    {
+      // reset pool
+      if (mIndex == mNumber)
+	mIndex = 0;
+      return mRays + mIndex ++;
+    }
+  protected:
+    VssRay *mRays;
+    int mIndex;
+    int mNumber;
+  };
+
+
+  VssRayPool mVssRayPool;
+  
+  void ReserveVssRayPool(const int n) 
+  {
+    mVssRayPool.Reserve(n);
+  }
+  
+  void InitPass() 
+  {
+    mVssRayPool.Clear();
+  }
+  
+  
 protected:
-
-	VssRay *RequestRay(const Vector3 &origin, 
-		const Vector3 &termination, 
-		Intersectable *originObject, 
-		Intersectable *terminationObject, 
-		const int pass, 
-		const float pdf);
-
-	void _SortRays(SimpleRayContainer &rays,
-		const int l,
-		const int r,
-		const int depth,
-		float box[12]);
-
-	struct Intersection
-	{
-		Intersection(): mObject(NULL), mFaceId(0)
-		{}
-
-		Intersection(const Vector3 &p, const Vector3 &n, Intersectable *o, const int f):
-		mPoint(p), mNormal(n), mObject(o), mFaceId(f)
-		{}
-
-		Intersection(const Vector3 &p): mPoint(p), mObject(NULL), mFaceId(0)
-		{}
-
-
-		////////////
-
-		Vector3 mPoint;
-		Vector3 mNormal;
-		Intersectable *mObject;
-		int mFaceId;
-	};
-
-
-	int ProcessRay(const SimpleRay &ray,
-		           Intersection &hitA,
-				   Intersection &hitB,
-				   VssRayContainer &vssRays,
-				   const AxisAlignedBox3 &box,
-				   const bool castDoubleRay,
-				   const bool pruneInvalidRays = true);
-
-	/** Checks if ray is valid.
-	I.e., the ray is in valid view space.
-	@note: clamps the ray to valid view space.
-	*/
-	bool ValidateRay(const Vector3 &origin,
-		             const Vector3 &direction,
-					 const AxisAlignedBox3 &box,
-					 Intersection &hit);
-
-	bool ClipToViewSpaceBox(const Vector3 &origin,
-                            const Vector3 &termination,
-							Vector3 &clippedOrigin,
-							Vector3 &clippedTermination);
-
-
-
-
-
-
-	const Preprocessor &mPreprocessor;
+  
+  VssRay *RequestRay(const Vector3 &origin, 
+		     const Vector3 &termination, 
+		     Intersectable *originObject, 
+		     Intersectable *terminationObject, 
+		     const int pass, 
+		     const float pdf);
+  
+  void _SortRays(SimpleRayContainer &rays,
+		 const int l,
+		 const int r,
+		 const int depth,
+		 float box[12]);
+  
+  struct Intersection
+  {
+    Intersection(): mObject(NULL), mFaceId(0)
+    {}
+    
+    Intersection(const Vector3 &p, const Vector3 &n, Intersectable *o, const int f):
+      mPoint(p), mNormal(n), mObject(o), mFaceId(f)
+    {}
+    
+    Intersection(const Vector3 &p): mPoint(p), mObject(NULL), mFaceId(0)
+    {}
+    
+    
+    ////////////
+    
+    Vector3 mPoint;
+    Vector3 mNormal;
+    Intersectable *mObject;
+    int mFaceId;
+  };
+
+
+  int ProcessRay(const SimpleRay &ray,
+		 Intersection &hitA,
+		 Intersection &hitB,
+		 VssRayContainer &vssRays,
+		 const AxisAlignedBox3 &box,
+		 const bool castDoubleRay,
+		 const bool pruneInvalidRays = true);
+  
+  /** Checks if ray is valid.
+      I.e., the ray is in valid view space.
+      @note: clamps the ray to valid view space.
+  */
+  bool ValidateRay(const Vector3 &origin,
+		   const Vector3 &direction,
+		   const AxisAlignedBox3 &box,
+		   Intersection &hit);
+  
+  bool ClipToViewSpaceBox(const Vector3 &origin,
+			  const Vector3 &termination,
+			  Vector3 &clippedOrigin,
+			  Vector3 &clippedTermination);
+  
+  const Preprocessor &mPreprocessor;
+#if 1
+public:
+  // Added by VH for debugging
+  Intersection intersect;
+#endif  
 };
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 2542)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 2575)
@@ -519,6 +519,6 @@
 bool
 Environment::GetStringValue(const char *name,
-							char *value,
-							const bool isFatal) const
+			    char *value,
+			    const bool isFatal) const
 {
   int i = FindOption(name, isFatal);
@@ -538,4 +538,27 @@
   return true;
 }
+
+bool
+Environment::GetStringValue(const char *name,
+			    string &stringVariable,
+			    const bool isFatal) const
+{
+  int i = FindOption(name, isFatal);
+
+  if (i<0)
+    return false;
+
+  
+  if (options[i].value != NULL) {
+    // option was not read, so use the default
+    stringVariable = options[i].value;
+  }
+  else {
+    // option was explicitly specified
+    stringVariable = options[i].defaultValue;
+  }
+  return true;
+}
+
 
 void
@@ -1069,5 +1092,5 @@
   numParams = 0;
   params = NULL;
-  maxOptions = 500;
+  maxOptions = 600;
 
   
@@ -2846,6 +2869,62 @@
 				 "true");
 
-	/////////////////////////////////////////////////////////////////
-
+  /////////////////////////////////////////////////////////////////
+  // By Vlastimil Havran
+  RegisterOption("BSP.splitclip", optBool,
+		 "kd_splitclip=", "false");
+  RegisterOption("BSP.emptyCut", optBool,
+		 "kd_emptycut=", "true");
+  RegisterOption("BSP.termCrit", optString,
+		 "kd_termcrit=", "auto");
+  RegisterOption("BSP.maxDepthAllowed", optInt,
+		 "kd_maxDepth=", "16");
+  RegisterOption("BSP.maxEmptyCutDepth", optInt,
+		 "kd_maxEmptyCutDepth=", "4");
+  RegisterOption("BSP.absMaxAllowedDepth", optInt,
+		 "kd_absMaxAllowedDepth=", "20");
+  RegisterOption("BSP.maxListLength", optInt,
+		 "kd_maxListLength=", "16");
+  RegisterOption("BSP.useRadixSort", optBool,
+		 "kd_useRadixSort=", "false");
+  RegisterOption("BSP.printCuts", optBool,
+		 "kd_printCuts=", "false");
+  RegisterOption("BSP.algAutoTermination", optInt,
+		 "kd_algAutoTermination=", "0");
+  RegisterOption("BSP.axisSelectionAlg", optInt,
+		 "kd_axisSelectAlg=", "0");
+  
+  RegisterOption("BSP.decisionCost", optFloat,
+		 "kd_decCost=", "0.3");
+  RegisterOption("BSP.intersectionCost", optFloat,
+		 "kd_intersectCost=", "0.9");
+  RegisterOption("BSP.traversalCost", optFloat,
+		 "kd_travCost=", "0.2");
+  RegisterOption("BSP.biasFreeCuts", optFloat,
+		 "kd_biasFreeCuts=", "0.9");
+
+  RegisterOption("BSP.minBoxes.use", optBool,
+		 "kd_minBoxesUse=", "false");
+  RegisterOption("BSP.minBoxes.tight", optBool,
+		 "kd_minBoxesTight=", "false");
+  RegisterOption("BSP.minBoxes.minObjects", optInt,
+		 "kd_minBoxesMinObjects=", "10");
+  RegisterOption("BSP.minBoxes.minDepthDistance", optInt,
+		 "kd_minBoxesMinDist=", "3");
+  RegisterOption("BSP.minBoxes.minSA2ratio", optFloat,
+		 "kd_minBoxesSA2ratio=", "1.0");
+
+  // The object used for testing
+  RegisterOption("Rays.file",
+		 optString,
+		 "rays_filename=",
+		 "data/fileRays_arena.txt");
+  RegisterOption("Rays.cnt",
+		 optInt,
+		 "rays_cnt=", "100000");
+  
+  RegisterOption("TestDoubleRays", optBool,
+		 "test_doublrays=", "false");
+
+  /////////////////////////////////////////////////////////////////
 }
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.h	(revision 1006)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.h	(revision 2575)
@@ -1,9 +1,11 @@
 #ifndef _FromPointVisibilityTree_H__
 #define _FromPointVisibilityTree_H__
+
+#include <stack>
+#include <fstream>
 
 #include "Mesh.h"
 #include "Containers.h"
 #include "Polygon3.h"
-#include <stack>
 #include "Statistics.h"
 #include "VssRay.h"
@@ -256,4 +258,6 @@
 	*/
 	int CastRay(Ray &ray);
+        int CastSimpleRay(const SimpleRay &ray) { return 0;}
+        int CastSimpleRay(const SimpleRay &ray, int IndexRay) { return 0;}
 
 	/// bsp tree construction types
@@ -329,5 +333,5 @@
 	/** Writes tree to output stream
 	*/
-	bool Export(ofstream &stream);
+        bool Export(std::ofstream &stream);
 
 	/** Casts beam, i.e. a 5D frustum of rays, into tree.
@@ -690,5 +694,5 @@
 		@note: should be implemented as visitor
 	*/
-	void ExportNode(BspNode *node, ofstream &stream);
+  void ExportNode(BspNode *node, std::ofstream &stream);
 
 	/** Returns estimated memory usage of tree.
@@ -782,5 +786,5 @@
 	int mMaxViewCells;
 	
-	ofstream  mSubdivisionStats;
+  std::ofstream  mSubdivisionStats;
 
 	// if rays should be stored in leaves
@@ -812,5 +816,5 @@
 	//int mSplits;
 	/// subdivision stats output file
-	ofstream mSubdivsionStats;
+        std::ofstream mSubdivsionStats;
 	/// if random split axis should be used
 	bool mUseRandomAxis;
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.cpp	(revision 2543)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Intersectable.cpp	(revision 2575)
@@ -1,9 +1,21 @@
 #include "Intersectable.h"
+#include "SimpleRay.h"
+//#include "ktbconf.h"
 
 using namespace std;
 
+#if _WIN32
+#define ALIGN16 __declspec(align(16))
+#else
+ALIGN16 GALIGN16
+#endif
 
 namespace GtpVisibilityPreprocessor {
 
+
+// This is the result of computing intersection
+// static data member
+  ALIGN16  IntersectionStr
+  SimpleRay::IntersectionRes[32];
 
 Intersectable::Intersectable(): 
@@ -16,4 +28,5 @@
 #endif
 {}
+
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2574)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 2575)
@@ -20,4 +20,5 @@
 #include "VssRay.h"
 #include "IntelRayCaster.h"
+#include "HavranRayCaster.h"
 #include "InternalRayCaster.h"
 #include "GlobalLinesRenderer.h"
@@ -408,5 +409,7 @@
 	// intel ray caster can only trace triangles
 	int rayCastMethod;
-	Environment::GetSingleton()->GetIntValue("Preprocessor.rayCastMethod", rayCastMethod);
+	Environment::GetSingleton()->GetIntValue("Preprocessor.rayCastMethod",
+						 rayCastMethod);
+
 	vector<FaceParentInfo> *fi = 
 	  ((rayCastMethod == RayCaster::INTEL_RAYCASTER) && mLoadMeshes) ?
@@ -1044,8 +1047,21 @@
 
 	if (!mUseKdTree) {
-		// create just a dummy KdTree
-		mKdTree = new KdTree;
-		return true;
-	}
+	  // create just a dummy KdTree
+	  mKdTree = new KdTree;
+	  return true;
+	}
+
+	int rayCastMethod;
+	Environment::GetSingleton()->
+	  GetIntValue("Preprocessor.rayCastMethod", rayCastMethod);
+
+	if (rayCastMethod == 2) {
+	  //HavranRayCaster *hr =
+	  //  dynamic_cast<HavranRayCaster*>(mRayCaster);
+	  HavranRayCaster *hr =
+	    reinterpret_cast<HavranRayCaster*>(mRayCaster);
+	  hr->Build(this->mObjects);
+	  return true;
+	}	
 
 	// always try to load the kd tree
@@ -1117,12 +1133,12 @@
 	int rayCastMethod;
 	Environment::GetSingleton()->
-		GetIntValue("Preprocessor.rayCastMethod", rayCastMethod);
+	  GetIntValue("Preprocessor.rayCastMethod", rayCastMethod);
 
 	if (rayCastMethod == 0)
 	{
-		cout << "ray cast method: internal" << endl;
-		mRayCaster = new InternalRayCaster(*this);
-	}
-	else
+	  cout << "ray cast method: internal" << endl;
+	  mRayCaster = new InternalRayCaster(*this);
+	}
+	if (rayCastMethod == 1) 
 	{
 #ifdef GTP_INTERNAL
@@ -1130,4 +1146,9 @@
 	  mRayCaster = new IntelRayCaster(*this, externKdTree);
 #endif
+	}
+	if (rayCastMethod == 2) 
+	{
+	  cout << "ray cast method: havran" << endl;
+	  mRayCaster = new HavranRayCaster(*this);
 	}
 	
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h	(revision 2543)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/HierarchyManager.h	(revision 2575)
@@ -536,8 +536,8 @@
 protected:
 
-	friend VspTree;
-	friend OspTree;
-	friend BvHierarchy;
-	friend ViewCellsParseHandlers;
+	friend class VspTree;
+	friend class OspTree;
+	friend class BvHierarchy;
+	friend class ViewCellsParseHandlers;
 
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h	(revision 2574)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.h	(revision 2575)
@@ -49,4 +49,5 @@
 	friend class IntelRayCaster;
 	friend class InternalRayCaster;
+	friend class HavranRayCaster;
 
 public:
@@ -193,6 +194,6 @@
 
 	static bool LoadObjects(const string &filename,
-		                    ObjectContainer &pvsObjects, 
-							const ObjectContainer &preprocessorObject);
+				ObjectContainer &pvsObjects, 
+				const ObjectContainer &preprocessorObject);
 
 
@@ -275,5 +276,6 @@
 	bool ExportBinaryObj(const std::string &filename, SceneGraphNode *root);
 
-	void SetupRay(Ray &ray, const Vector3 &point, const Vector3 &direction) const;
+	void SetupRay(Ray &ray, const Vector3 &point,
+		      const Vector3 &direction) const;
 
 	void EvalPvsStat();
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h	(revision 2547)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/VspTree.h	(revision 2575)
@@ -12,5 +12,7 @@
 #include "SubdivisionCandidate.h"
 #include "HierarchyManager.h"
+#ifdef PERFTIMER
 #include "Timer/PerfTimer.h"
+#endif // PERFTIMER
 
 
@@ -294,5 +296,5 @@
 class VspLeaf: public VspNode 
 {
-	friend VspTree;
+  friend class VspTree;
 
 public:
@@ -670,4 +672,5 @@
 	////////////
 
+#ifdef PERFTIMER  
 	PerfTimer mSortTimer;
 	PerfTimer mSplitTimer;
@@ -677,5 +680,6 @@
 	PerfTimer mPlaneTimer;
 	PerfTimer mViewCellsTimer;
-
+#endif 
+  
 protected:
 
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Triangle3.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Triangle3.h	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Triangle3.h	(revision 2575)
@@ -9,4 +9,5 @@
 class AxisAlignedBox3;
 class Ray;
+class SimpleRay;
 class Plane3;
 
@@ -32,4 +33,6 @@
 	int CastRay(const Ray &ray, float &t, const float nearestT, Vector3 &normal) const;
 
+	int CastSimpleRay(const SimpleRay &ray, float &t, const float nearestT) const;
+  
 	friend std::ostream& operator<< (std::ostream &s, const Triangle3 &A);
 	friend std::istream& operator>> (std::istream &s, Triangle3 &A);
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/Trackball.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/Trackball.cpp	(revision 2347)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/Trackball.cpp	(revision 2575)
@@ -50,6 +50,6 @@
  * Gavin Bell
  */
-#include <math.h>
-#include "trackball.h"
+#include <cmath>
+#include "Trackball.h"
 
 /*
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h	(revision 2548)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/SamplingStrategy.h	(revision 2575)
@@ -48,4 +48,5 @@
 		HW_GLOBAL_LINES_DISTRIBUTION,
 		VIEWCELL_BASED_DISTRIBUTION,
+		FILTER_BASED_DISTRIBUTION,
 		DIFFERENCE_SAMPLING_BASED_DISTRIBUTION,
 	};
